( Display RC5 key-codes on a seven segment display...
  We have to adjust the I/O because RC5 needs P2.0 {and P2.4}.
  The next step could be making one target file so we only 
  have to take what is realy wanted and/or needed. )

\ Relocated I/O pins en changed setup!!!
: READY     02 029 ;            \ Bit P2.2 - strobe 74HC4094
: DATA      04 029 ;            \ Bit P2.3 - data 74HC4094
: CLOCK     08 029 ;            \ Bit P2.4 - cp 74HC4094
: INIT-SPI  0E 02A *bis ;

( u*8 bits output uses no more than only 3 I/O-bits )
: WRITE-BIT       ( flag -- )         ( Write one bit to 74HC4094 )
    if  data *bis else data *bic  then  clock *bic clock *bis ;

: SHOW              ( -- )              ( Set data on 74HC4094 outputs )
    ready *bis ready *bic ;
 
: >DRIVER           ( x -- )            ( Schrijf x naar display )
    8 0 do                              ( display driver )
        dup 80 and write-bit  2*
    loop
    drop ;

( Make numbers for an seven segment display using 74HC4094 0 t/m F and dot )
( Layout of 7-segm. Display  +-04-+ )
(                            20  08 )
( Driver 74HC4094            +-10-+ )
(                            40  01 )
( Dec. dot is 02 !!          +-80-+ )
CREATE NUMBERS         ( Building characters )
  bn 00010010 c, bn 11110110 c, bn 00100011 c, bn 01100010 c, ( 0, 1, 2, 3 )
  bn 11000110 c, bn 01001010 c, bn 00001010 c, bn 11110010 c, ( 4, 5, 6, 7 )
  bn 00000010 c, bn 01000010 c, bn 10000010 c, bn 00001110 c, ( 8, 9, A, b )
  bn 00011011 c, bn 00100110 c, bn 00001011 c, bn 10001011 C, ( C, d, E, F )
  bn 11101111 c, bn 11111101 c, bn 11111111 c,  align         ( -, ., and off )

: >DISPLAY          ( u -- )            ( Send number u to digits )
    12 umin  numbers   +                ( From binary to 7-segment )
    c@  >driver  show ;                 ( And show it ! )

: FLASH         ( -- )                  ( Show startup: F and - )
    0F >display  150 ms
    10 >display  150 ms
    12 >display  150 ms ;

\ We have to initialize the remote control decoder, put off the lamp output
\ and initalize the spi interface. After that we show startup and go
\ in the endless test loop, showing decoded characters for .5 sec.
: display       ( -- )
    rc-on  lamp *bic  init-spi  flash
    begin
        begin  key? if exit then  rckey? until
        rckey 1F and  11 umin 
        >display  200 ms 12 >display ( off )
    again 
    rc-off ;

shield display\  freeze

\ End
