( For noForth C2553 lp.0, C&V version: Port input at P1 & output at P2 
  with MSP430G2553 )

( Port-2 must be wired to 8 leds, placed on the launchpad experimenters kit.
  Wire P2.0 to P2.7 to the anode of eight 3mm leds placed on the breadboard 
  the pinlayout can be found in the hardwaredoc of the launchpad.
  Note: XIN is also P2.6 and XOUT is P2.7!! Connect all kathodes to each 
  other, and connect them to ground using a 100 Ohm resistor.
  Port-1 bit 3 holds a switch on the Launchpad board. )
  
( The most hard to find data are those for the selection registers. 
  To find the data for the selection register of Port-2 here 02E you have to
  go to the "Port Schematics". This starts on page 42 of SLAS735E.PDF, for 
  P2 the tables are found from page 50 and further. These tables say which 
  function will be on each I/O-bit at a specific setting of the registers. )

HEX
( Address 020 = p1in, port-1 input register
  Address 022 = p1dir, port-1 direction register
  Address 029 = p2out, port-2 output with 8 leds
  Address 02A = p2dir, port-2 direction register
  Address 02E = p2sel, port-2 selection register )

\ Use bit 3 to make a delay value (S?)
: WAIT          ( -- )      008 ( bit-3 ) 020 ( p1in ) bit* 5 + dm 10 * ms ;
: >LEDS         ( b -- )    029 ( p2out ) c! ;  \ Store pattern b at leds

: FLASH         ( -- )   \ Visualise startup
    -1 >leds  064 ms     \ All leds on
    00 >leds  064 ms ;   \ All leds off

: SETUP-PORTS   ( -- )
    08 022 ( p1dir ) *bic  \ Port-1 bit 3 is input (S?)
    00 02E ( p2sel) c!     \ Port-2 all bits I/O
    -1 02A ( p2dir ) c!    \ All bits of P2 are outputs
    ;

: COUNTER       ( -- )  \ Binary counter
    setup-ports  flash
    0                   \ Counter on stack
    begin
        1+              \ Increase counter
        dup >leds  wait
    key? until          \ Until key pressed
    drop ;

: RUNNER        ( -- )  \ A running light
    setup-ports  flash
    begin
        8 0 do          \ Loop eight times
            1 i lshift  \ Make bitpattern
            >leds  wait
        loop
    key? until          \ Until a key is pressed
    ;

shield io\
' counter to app  freeze
