\ Switch routines for different DCO frequencies
\ Data comes from info-flash segment A at 10C0
\ Start of data for DCO from 10F6
\ Flash clock must be from 257KHz to 476KHz
\ The default selected baudrate is 38400 baud!!!
\ The assembler loads in five seconds, linedelay = 35 ms

hex
: 8MHZ      ( -- )   \ Baudrate 38K4
\ DCO
    10FD c@ 0057 c!  \ 10fd & clkctrl & .b mov   \ set dco = 8 mhz
    10FC c@ 0056 c!  \ 10fc & dcoctrl & .b mov
\ UART   
    0080 0061 *bis   \ UCA0CTL  uart use smclk
    00D0 0062 c!     \ UCA0BR0  8 mhz, baudrate 38400
    0000 0063 c!     \ UCA0BR1  idem
    0006 0064 c!     \ UCAMCTL  modulation ucbrsx = 3
    0001 0061 *bic   \ UCA0CTL  initialize usci state machine
\ flash initialisation
    A550 012A !      \ a550 # fctrl2 & mov          \ mclk/17=470KHz flash timing
    01C0 TO MS)
   ;

hex
: 16MHZ     ( -- )   \ Baudrate 38K4
    10F9 c@ 0057 c!  \ Set DCO = 16MHz
    10F8 c@ 0056 c!    
    0080 0061 *bis   \ uart use smclk
    00A0 0062 c!     \ 8 mhz, baudrate 38400
    0001 0063 c!
    000C 006C c!     \ modulation ucbrsx = 6
    0001 0061 *bic   \ initialize usci state machine
    A562 012A !      \ mclk/34=470KHz
    0380 TO MS)
    ;

hex
: 1MHZ      ( -- )   \ Baudrate 38K4
    10FF c@ 0057 c!  \ Set DCO = 1MHz
    10FE c@ 0056 c!  
    0080 0061 *bis   \ uart use smclk
    001A 0062 c!     \ 1 mhz, baudrate 38400
    0000 0063 c!     \ idem
    0000 0064 c!     \ modulation ucbrsx = 0
    0001 0061 *bic   \ initialize usci state machine
    A522 012A !      \ mclk/3=333KHz
    0038 TO MS)
    ;

shield xt\  ' 16mhz to app  freeze
    